	INCLUDE EFR32MG12.inc		; CPU register definitions
	INCLUDE terminal.inc	
	EXPORT	main
	EXPORT	__main		

	EXTERN	__0sscanf

;-------------------------------------	; non-initialized DATA segment in RAM 
	AREA	RAM, DATA, NOINIT, READWRITE, ALIGN=3
f	SPACE	8	

;-------------------------------------	; CODE segment in flash (ROM)
	AREA    |.text|, CODE, READONLY
__main
main	PROC				; main user code
	PUTW	0x02, EMU_PWRCFG, EMU		; unlock DCDC registers
	OORW	15<<16, EMU_DCDCMISCCTRL	; set 320mA current limit
	OORW	1<<13, EMU_DCDCCLIMCTRL		; enable current limiter
	PUTW	0, EMU_DCDCCTRL			; bypass DCDC
	PUTW	1<<10, EMU_PWRCTRL		; power analog blocks from DVDD
	
	PUTW	0x190, CMU_OSCENCMD, CMU	; enable LFXO
CMU_0	
	GETW	CMU_STATUS			; R1 = status
	ands	R1, #(1<<9)
	beq	CMU_0				; wait for LFXO stabilize
	
	PUTW	1, CMU_HFCLKSEL			; select 19 MHz HFRCO as closk source
	OORW	1<<2, CMU_HFBUSCLKEN0		; enable LE clock access
	PUTW	2, CMU_LFACLKSEL		; set LFXO as LFA
	PUTW	2, CMU_LFECLKSEL	

	bl	Terminal_setup		; setup TeraTerm communication
	
	OORW	(0xF<<20), 0, CPACR	; enable FPU
	dsb				; must follow the previous instruction	

loop
; 	vldr.f	S0, =-23.45

	ldr	R0, =str1
	ldr	R1, =str2
	ldr	R2, =f
	bl	__0sscanf

	ldr	R0, =s
	bl	WriteString
	bl	ReadFloat
	bl 	WriteFloat
	bl	NewLine
	b	loop
	ENDP

s	DCB	"Enter a number: ", 0
str1	DCB	"1.5", 0
str2	DCB	"%f", 0
	ALIGN	
	END
		
		